using System.Windows.Forms;
using System.Data;
using Infragistics.Win.UltraWinGrid;
using System;
using Infragistics.Win;
using System.Collections.Generic;
using System.Drawing;
namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable dt1;

        private void Form1_Load(object sender, System.EventArgs e)
        {
            // Set grid's DataSource            
            dt1 = DummyDataCreator.GetData(10);

            dt1.TableName = "Band 0";

            this.ultraGrid1.SetDataBinding(dt1, null);
        }       

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            UltraGridOverride ov = layout.Override;

            layout.UseFixedHeaders = true;
            ov.FixedHeaderIndicator = FixedHeaderIndicator.None;

            // Make the fixed columns easier to see. 
            ov.FixedCellAppearance.BackColor = Color.Yellow;
        }

        Infragistics.Win.UltraWinGrid.ColumnHeader lastColumnHeaderClicked = null;
        private void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            // If the mouse is over a column header, assign the ContextMenuStrip to the grid. 
            // If the mouse is not over a column header, remove the ContextMenuStrip. 
            UltraGrid grid = (UltraGrid)sender;
            Infragistics.Win.UltraWinGrid.ColumnHeader columnHeader = GetColumnHeader(grid);
            if (columnHeader != null)
            {
                this.lastColumnHeaderClicked = columnHeader;
                grid.ContextMenuStrip = this.contextMenuStrip1;
            }
            else
            {
                this.lastColumnHeaderClicked = null;
                grid.ContextMenuStrip = null;
            }
        }

        private static Infragistics.Win.UltraWinGrid.ColumnHeader GetColumnHeader(UltraGrid grid)
        {
            // Get the column header associated with the last mouse position over the grid. 
            UIElement lastElementEntered = grid.DisplayLayout.UIElement.LastElementEntered;
            Infragistics.Win.UltraWinGrid.ColumnHeader columnHeader = lastElementEntered.GetContext(typeof(Infragistics.Win.UltraWinGrid.ColumnHeader)) as Infragistics.Win.UltraWinGrid.ColumnHeader;
            if (columnHeader != null)
            {
                return columnHeader;
            }

            return null;
        }


        private void fixThisColumnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            UltraGrid grid = this.ultraGrid1;

            // Get the column header which was right-clicked. We will fix all columns up to this
            // one, and unfix all columns after it. 
            Infragistics.Win.UltraWinGrid.ColumnHeader columnHeader = this.lastColumnHeaderClicked;

            if (columnHeader != null)
            {
                // We need to build an initial list of visible columns. We have to build this 
                // list up-front because the column's positions may change as we go through the 
                // list and set the Fix property. So we need to maintain a separate list 
                // that doesn't change when we set properties on the columns. 
                List<UltraGridColumn> visibleColumns = this.GetVisibileColumns(grid);
                
                bool fix = true;
                foreach (UltraGridColumn column in visibleColumns)
                {
                    // Set the fixed property on each column. We will start off setting fixed
                    // to true until we reach the colmun that was right-clicked. Then we 
                    // will set Fixed to false on any subsequent columns. 
                    column.Header.Fixed = fix;
                    if (column.Header == columnHeader)
                        fix = false;
                }
            }
        }

        private List<UltraGridColumn> GetVisibileColumns(UltraGrid grid)
        {
            // Build a list of the columns in the first band of the grid in their visible order. 
            List<UltraGridColumn> visibleColumns = new List<UltraGridColumn>(this.ultraGrid1.DisplayLayout.Bands[0].Columns.Count);
            UltraGridColumn column = grid.DisplayLayout.Bands[0].Columns[0].GetRelatedVisibleColumn(VisibleRelation.First);
            while (column != null)
            {
                visibleColumns.Add(column);
                column = column.GetRelatedVisibleColumn(VisibleRelation.Next);
            }
            return visibleColumns;
        }

        private void unfixAllColumnsToolStripMenuItem_Click(object sender, EventArgs e)
        {            
            // Unfix all of the columns. 
            foreach (UltraGridColumn column in this.ultraGrid1.DisplayLayout.Bands[0].Columns)
            {
                column.Header.Fixed = false;
            }
        }
    }
}